slotSettingsSide1 = {};

function slotSettingsSide1:generate(installModGuiTablePos, masterPage, slavePage, pageSide)
	----is line/button a pullDownMenue ---> check is pullDownOpen or not --> g_currentMission.guiMenue.master.isPullDownOpen()		
	local isGenerate, errorTxt = true, "";
	function printError()
		if not isGenerate and string.len(tostring(errorTxt)) > 0 then print(tostring(errorTxt));end;
	end;	
	local lineButtonTable = {};	
	local lineCmdTable = {};
	--line 1	
	function comp(w1,w2)			
		if w1[2] < w2[2] then
			return true;
		end;			
	end;
	local mohSLOTs = moSetGetMohSLOT:getSLOTs();
	table.sort(mohSLOTs, comp);
	lineCmdTable = {};	
	for slot=1, #mohSLOTs do		
		lineCmdTable[slot] = {};
		lineCmdTable[slot].cmdTable = nil;
		lineCmdTable[slot].cmdValue = nil;
		lineCmdTable[slot].cmdType = "stringOnly";
		lineCmdTable[slot].buttonTxt = tostring(mohSLOTs[slot][2]);
		lineCmdTable[slot].modOnlyInfo = tostring(mohSLOTs[slot][1]);
		lineCmdTable[slot].isSelect = tostring(mohSLOTs[slot][1]) == "masterSLOT_";
		if tostring(mohSLOTs[slot][1]) == "masterSLOT_" then
			lineCmdTable[slot].infoTxt = "This Master Slot can not delete";
		else
			lineCmdTable[slot].infoTxt = "!! Warning !! Delete SLOT is irrevocable, with(incl.) all Cmd and Settings.";
		end;
	end;
	lineButtonTable = {};
	lineButtonTable[#lineButtonTable+1] = {
		returnClick = "slotSettingsSelect_";
		isHidden = false; 
		buttonType = 2; 
		buttonWidth = 0; 		
		txtOverButton = "Select Slot"; 
		helpIcon = 1; 
		helpTxt = {"Activate Backup ... XML to safeness\nand/or Safeness delete confirm (your decision)\nis Delete ... empty then need not confirm"};
		infoTxt = "Select Delete Slot";
		cmdTable = lineCmdTable;
		cmdValue = nil;
		cmdType = "pullDown_1";
		buttonTxt = ""; 
	};
	lineButtonTable[#lineButtonTable+1] = {
		returnClick = "slotSettingsDelete_";
		isHidden = false; 
		buttonType = 8; 
		buttonWidth = -8; 		
		txtOverButton = "Delete Slot"; 
		txtOverButtonColor = moColors.intern["orangeRed"];
		helpIcon = 1; 
		helpTxt = {"Activate Backup ... XML to safeness\nand/or Safeness delete confirm (your decision)\nis Delete ... empty then need not confirm"};
		infoTxt = "Delete Select Slot";
		cmdTable = nil;
		cmdValue = nil;
		cmdType = "stringOnly";
		buttonTxt = "Delete Slot";
	};
	isGenerate, errorTxt = g_currentMission.guiMenue.guiSetGetMenue:generateModMenuePageSideLine( {modMenueTable=installModGuiTablePos, masterPage=masterPage, slavePage=slavePage, pageSide=pageSide, line=1, maxButtons=2, isHidden=false, lineButtonTable=lineButtonTable} );
	printError();
	--line 1
	--line 2
	lineButtonTable = {};
	lineButtonTable[#lineButtonTable+1] = {
		returnClick = "slotZoomOuIn_";
		isHidden = false; 
		buttonType = 3; 
		buttonWidth = 0; 		
		txtOverButton = "Zoom In/Out"; 
		helpIcon = 1; 
		helpTxt = {"Min zoomIn ".. tostring(moSetGetOverlays.slot["masterSLOT_"].minZoomOutInTemp).. "\nDefault zoomInOut ".. tostring(moSetGetOverlays.slot["masterSLOT_"].defaultZoomOutInTemp).. "\nMax zoomOut ".. tostring(moSetGetOverlays.slot["masterSLOT_"].maxZoomOutInTemp)};
		infoTxt = "Min/Max ZoomInOut for SLOT";
		cmdTable = moSetGetOverlays.slot["masterSLOT_"];
		cmdValue = "zoomOutInTemp";
		cmdType = "float";
		buttonTxt = 0.1;
	};
	lineButtonTable[#lineButtonTable+1] = {
		returnClick = "slotTextWidthFix_";
		isHidden = false; 
		buttonType = 3; 
		buttonWidth = 0; 		
		txtOverButton = "Text Width Fix";		
		helpIcon = 1; 
		helpTxt = {"Default Text Width Fix ".. tostring(moSetGetOverlays.slot["masterSLOT_"].defaultTxtWidthFix)};
		infoTxt = "Can Fix Width Text Problem with Ü Ä etc.";
		cmdTable = moSetGetOverlays.slot["masterSLOT_"];
		cmdValue = "txtWidthFix";
		cmdType = "int";
		buttonTxt = "";
	};
	isGenerate, errorTxt = g_currentMission.guiMenue.guiSetGetMenue:generateModMenuePageSideLine( {modMenueTable=installModGuiTablePos, masterPage=masterPage, slavePage=slavePage, pageSide=pageSide, line=2, maxButtons=2, isHidden=false, lineButtonTable=lineButtonTable} );
	printError();	
	--line 2
	--line 3
	lineButtonTable = {};
	lineButtonTable[#lineButtonTable+1] = {
		returnClick = "slotHorizontalTxtDistance_";
		isHidden = false; 
		buttonType = 3; 
		buttonWidth = 0; 		
		txtOverButton = "Horizontal Txt Dis."; 
		helpIcon = 1; 
		helpTxt = {"Default Horizontal Text Distance ".. tostring(moSetGetOverlays.slot["masterSLOT_"].defaultHorizontalTxtDistance)};
		infoTxt = "Horizontal Text Distance for SLOT";
		cmdTable = moSetGetOverlays.slot["masterSLOT_"];
		cmdValue = "horizontalTxtDistance";
		cmdType = "float";
		buttonTxt = 0.3;
	};
	lineButtonTable[#lineButtonTable+1] = {
		returnClick = "slotVerticalTxtDistance_";
		isHidden = false; 
		buttonType = 3; 
		buttonWidth = 0; 		
		txtOverButton = "Vertical Txt Dis.";		
		helpIcon = 1; 
		helpTxt = {"Default Vertical Text Distance ".. tostring(moSetGetOverlays.slot["masterSLOT_"].defaultVerticalTxtDistance)};
		infoTxt = "Vertical Text Distance for Slot\nIs Button at Line and not Correct Pos set 1x ZoomOutIn up and down(for Pos Reset)";
		cmdTable = moSetGetOverlays.slot["masterSLOT_"];
		cmdValue = "verticalTxtDistance";
		cmdType = "float";
		buttonTxt = 0.3;
	};
	isGenerate, errorTxt = g_currentMission.guiMenue.guiSetGetMenue:generateModMenuePageSideLine( {modMenueTable=installModGuiTablePos, masterPage=masterPage, slavePage=slavePage, pageSide=pageSide, line=3, maxButtons=2, isHidden=false, lineButtonTable=lineButtonTable} );
	printError();	
	--line 3
	--line 4
	lineButtonTable = {};
	lineButtonTable[#lineButtonTable+1] = {
		returnClick = "slotTxtSize_";
		isHidden = false; 
		buttonType = 3; 
		buttonWidth = 0; 		
		txtOverButton = "Text Size"; 
		helpIcon = 1; 
		helpTxt = {"Min Size ".. tostring(moSetGetOverlays.slot["masterSLOT_"].minSize).. "\nDefault Size ".. tostring(moSetGetOverlays.slot["masterSLOT_"].defaultSize).. "\nMax Size ".. tostring(moSetGetOverlays.slot["masterSLOT_"].maxSize)};
		infoTxt = "Text Size for SLOT";
		cmdTable = moSetGetOverlays.slot["masterSLOT_"];
		cmdValue = "size";
		cmdType = "float";
		buttonTxt = 0.3;
	};
	isGenerate, errorTxt = g_currentMission.guiMenue.guiSetGetMenue:generateModMenuePageSideLine( {modMenueTable=installModGuiTablePos, masterPage=masterPage, slavePage=slavePage, pageSide=pageSide, line=4, maxButtons=2, isHidden=false, lineButtonTable=lineButtonTable} );
	printError();	
	--line 4
end;

function slotSettingsSide1:setReturnClick(self, returnClick, whichPDA, isPullDownOpen, clickLine, clickButton, masterPage, slavePage, pageSide, isVirtualReturnClick) --byName (virtual.... for Activate over Mod(not over Gui Menue click)for set Icons or at GuiMenue or or etc)
	local whichSubPDA = whichPDA or "masterPDA_";
	local upOrLeft = string.find(returnClick, "_Up") or string.find(returnClick, "_Left");
	local downOrRight = string.find(returnClick, "_Down") or string.find(returnClick, "_Right");
	
	local defaultPageSide = 1; --ändern wenn die seite verschoben wird
	
	if string.find(returnClick, "slotSettingsSelect_") and not isPullDownOpen then		
		local getThisButtonPage = g_currentMission.guiMenue.guiSetGet:getButtonInfo( {modMenueTable=MultiOverlayV3.guiMenue.modTable, pageSide=defaultPageSide, name="slotSettingsSelect_"} );
		if getThisButtonPage == nil then return;end;
		local guiPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[getThisButtonPage.masterPage].side[getThisButtonPage.pageSide];
		local buttonTable = Utils.getNoNil(guiPageTable.line[getThisButtonPage.line].button[getThisButtonPage.button], nil);
		local selectLine = moSetGetGuiMenue:getSelectPullDownLine(self, nil, nil, buttonTable);
		local whichSLOT = buttonTable.cmdTable[selectLine].modOnlyInfo;
		slotSettingsSide1:resetSlotGuiMenue(whichSLOT);
		moSetGetMohSLOT.openSLOT(whichSLOT, true);
		return;
	elseif string.find(returnClick, "slotSettingsDelete_") then
		local getThisButtonPage = g_currentMission.guiMenue.guiSetGet:getButtonInfo( {modMenueTable=MultiOverlayV3.guiMenue.modTable, pageSide=defaultPageSide, name="slotSettingsSelect_"} );			
		if getThisButtonPage == nil then return;end;
		local guiPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[getThisButtonPage.masterPage].side[getThisButtonPage.pageSide];
		if getThisButtonPage.slavePage ~= nil then guiPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[getThisButtonPage.masterPage].page[getThisButtonPage.slavePage].side[getThisButtonPage.pageSide];end;
		if not isPullDownOpen then
			local buttonTable = Utils.getNoNil(guiPageTable.line[getThisButtonPage.line].button[getThisButtonPage.button], nil);			
			local selectLine = moSetGetGuiMenue:getSelectPullDownLine(self, nil, nil, buttonTable);
			if buttonTable.cmdTable[selectLine].modOnlyInfo == "masterSLOT_" then
				g_currentMission:showBlinkingWarning("This Master SLOT can not be deleted", 2000);
				return;
			else
				local isEmpty = moConfirm:isEmpty(nil, buttonTable.cmdTable[selectLine].modOnlyInfo, "outputSlot");
				deleteCoroutineByWhat = coroutine.create(moConfirm.deleteSlotByWhat);	
				coroutine.resume(deleteCoroutineByWhat, "outputSlot", buttonTable.cmdTable[selectLine].modOnlyInfo);
				if moGeneralSettings.deleteConfirm and not isEmpty then	
					g_currentMission.guiMenue.guiSetGet:openLsOrGuiMenueDialog("LsYesNoDialog", {onCloseCallback=moConfirm.deleteOutputSlot , dialogTitel=tostring(MultiOverlayV3.metadata.title), dialogText1="Is Not Empty\n! Delete SLOT ".. tostring(moSetGetOverlays.slot[buttonTable.cmdTable[selectLine].modOnlyInfo].name).. " !\nDelete SLOT is irrevocable, with(incl.) all Cmd Settings."})
					return;
				else
					moConfirm.deleteOutputSlot(true);
				end;
			end;
		end;
		return;
	elseif string.find(returnClick, "slotZoomOuIn_") and not isPullDownOpen then
		local getThisButtonPage = g_currentMission.guiMenue.guiSetGet:getButtonInfo( {modMenueTable=MultiOverlayV3.guiMenue.modTable, pageSide=defaultPageSide, name="slotSettingsSelect_"} );
		if getThisButtonPage == nil then return;end;
		local guiPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[getThisButtonPage.masterPage].side[getThisButtonPage.pageSide];
		local buttonTable = Utils.getNoNil(guiPageTable.line[getThisButtonPage.line].button[getThisButtonPage.button], nil);
		local selectLine = moSetGetGuiMenue:getSelectPullDownLine(self, nil, nil, buttonTable);
		local whichSLOT = buttonTable.cmdTable[selectLine].modOnlyInfo;
		local zoomLevel = 0.1;
		if upOrLeft then
			if moSetGetOverlays.slot[whichSLOT].zoomOutInTemp+zoomLevel > moSetGetOverlays.slot[whichSLOT].maxZoomOutInTemp then return;end;
			moSetGetOverlays.slot[whichSLOT].zoomOutInTemp = moSetGetOverlays.slot[whichSLOT].zoomOutInTemp+zoomLevel;					
		elseif downOrRight then
			if moSetGetOverlays.slot[whichSLOT].zoomOutInTemp-zoomLevel < moSetGetOverlays.slot[whichSLOT].minZoomOutInTemp then return;end;
			moSetGetOverlays.slot[whichSLOT].zoomOutInTemp = moSetGetOverlays.slot[whichSLOT].zoomOutInTemp-zoomLevel;					
		end;
		moSetGetOverlays:loadSlotOverlays(self, true, whichSLOT);
		moSetGetOverlays.slot[whichSLOT].save = false;
		return;
	elseif string.find(returnClick, "slotTextWidthFix_") and not isPullDownOpen then
		local getThisButtonPage = g_currentMission.guiMenue.guiSetGet:getButtonInfo( {modMenueTable=MultiOverlayV3.guiMenue.modTable, pageSide=defaultPageSide, name="slotSettingsSelect_"} );
		if getThisButtonPage == nil then return;end;
		local guiPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[getThisButtonPage.masterPage].side[getThisButtonPage.pageSide];
		local buttonTable = Utils.getNoNil(guiPageTable.line[getThisButtonPage.line].button[getThisButtonPage.button], nil);
		local selectLine = moSetGetGuiMenue:getSelectPullDownLine(self, nil, nil, buttonTable);
		local whichSLOT = buttonTable.cmdTable[selectLine].modOnlyInfo;
		local zoomLevel = 1;
		if upOrLeft then
			if moSetGetOverlays.slot[whichSLOT].txtWidthFix+zoomLevel > moSetGetOverlays.slot[whichSLOT].maxTxtWidthFix then return;end;
			moSetGetOverlays.slot[whichSLOT].txtWidthFix = moSetGetOverlays.slot[whichSLOT].txtWidthFix+zoomLevel;					
		elseif downOrRight then
			if moSetGetOverlays.slot[whichSLOT].txtWidthFix-zoomLevel < 0 then return;end;
			moSetGetOverlays.slot[whichSLOT].txtWidthFix = moSetGetOverlays.slot[whichSLOT].txtWidthFix-zoomLevel;					
		end;		
		moSetGetOverlays.slot[whichSLOT].save = false;
		moSetGetMohSLOT:resetRenderViewText(whichSLOT);
		return;		
	elseif string.find(returnClick, "slotHorizontalTxtDistance_") and not isPullDownOpen then
		local getThisButtonPage = g_currentMission.guiMenue.guiSetGet:getButtonInfo( {modMenueTable=MultiOverlayV3.guiMenue.modTable, pageSide=defaultPageSide, name="slotSettingsSelect_"} );
		if getThisButtonPage == nil then return;end;
		local guiPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[getThisButtonPage.masterPage].side[getThisButtonPage.pageSide];
		local buttonTable = Utils.getNoNil(guiPageTable.line[getThisButtonPage.line].button[getThisButtonPage.button], nil);
		local selectLine = moSetGetGuiMenue:getSelectPullDownLine(self, nil, nil, buttonTable);
		local whichSLOT = buttonTable.cmdTable[selectLine].modOnlyInfo;
		local zoomLevel = 0.001;
		if upOrLeft then
			if moSetGetOverlays.slot[whichSLOT].horizontalTxtDistance+zoomLevel > moSetGetOverlays.slot[whichSLOT].maxHorizontalTxtDistance then return;end;
			moSetGetOverlays.slot[whichSLOT].horizontalTxtDistance = moSetGetOverlays.slot[whichSLOT].horizontalTxtDistance+zoomLevel;					
		elseif downOrRight then
			if moSetGetOverlays.slot[whichSLOT].horizontalTxtDistance-zoomLevel < 0 then return;end;
			moSetGetOverlays.slot[whichSLOT].horizontalTxtDistance = moSetGetOverlays.slot[whichSLOT].horizontalTxtDistance-zoomLevel;					
		end;		
		moSetGetOverlays.slot[whichSLOT].save = false;
		return;
	elseif string.find(returnClick, "slotVerticalTxtDistance_") and not isPullDownOpen then
		local getThisButtonPage = g_currentMission.guiMenue.guiSetGet:getButtonInfo( {modMenueTable=MultiOverlayV3.guiMenue.modTable, pageSide=defaultPageSide, name="slotSettingsSelect_"} );
		if getThisButtonPage == nil then return;end;
		local guiPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[getThisButtonPage.masterPage].side[getThisButtonPage.pageSide];
		local buttonTable = Utils.getNoNil(guiPageTable.line[getThisButtonPage.line].button[getThisButtonPage.button], nil);
		local selectLine = moSetGetGuiMenue:getSelectPullDownLine(self, nil, nil, buttonTable);
		local whichSLOT = buttonTable.cmdTable[selectLine].modOnlyInfo;
		local zoomLevel = 0.001;
		if upOrLeft then
			if moSetGetOverlays.slot[whichSLOT].verticalTxtDistance+zoomLevel > moSetGetOverlays.slot[whichSLOT].maxVerticalTxtDistance then return;end;
			moSetGetOverlays.slot[whichSLOT].verticalTxtDistance = moSetGetOverlays.slot[whichSLOT].verticalTxtDistance+zoomLevel;					
		elseif downOrRight then
			if moSetGetOverlays.slot[whichSLOT].verticalTxtDistance-zoomLevel < 0 then return;end;
			moSetGetOverlays.slot[whichSLOT].verticalTxtDistance = moSetGetOverlays.slot[whichSLOT].verticalTxtDistance-zoomLevel;					
		end;		
		moSetGetOverlays.slot[whichSLOT].save = false;
		return;
	elseif string.find(returnClick, "slotTxtSize_") and not isPullDownOpen then
		local getThisButtonPage = g_currentMission.guiMenue.guiSetGet:getButtonInfo( {modMenueTable=MultiOverlayV3.guiMenue.modTable, pageSide=defaultPageSide, name="slotSettingsSelect_"} );
		if getThisButtonPage == nil then return;end;
		local guiPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[getThisButtonPage.masterPage].side[getThisButtonPage.pageSide];
		local buttonTable = Utils.getNoNil(guiPageTable.line[getThisButtonPage.line].button[getThisButtonPage.button], nil);
		local selectLine = moSetGetGuiMenue:getSelectPullDownLine(self, nil, nil, buttonTable);
		local whichSLOT = buttonTable.cmdTable[selectLine].modOnlyInfo;
		local zoomLevel = 0.0005;
		if upOrLeft then
			if moSetGetOverlays.slot[whichSLOT].size+zoomLevel > moSetGetOverlays.slot[whichSLOT].maxSize then return;end;
			moSetGetOverlays.slot[whichSLOT].size = moSetGetOverlays.slot[whichSLOT].size+zoomLevel;					
		elseif downOrRight then
			if moSetGetOverlays.slot[whichSLOT].size-zoomLevel < moSetGetOverlays.slot[whichSLOT].minSize then return;end;
			moSetGetOverlays.slot[whichSLOT].size = moSetGetOverlays.slot[whichSLOT].size-zoomLevel;					
		end;
		moSetGetOverlays.slot[whichSLOT].save = false;
		return;
	end;
	return;
end;

function slotSettingsSide1:resetSlotGuiMenue(whichSLOT)
	local whichSubSLOT = whichSLOT or "masterSLOT_";
	local defaultPageSide = 1; --ändern wenn die seite verschoben wird
	local getThisButtonPage = g_currentMission.guiMenue.guiSetGet:getButtonInfo( {modMenueTable=MultiOverlayV3.guiMenue.modTable, pageSide=defaultPageSide, name="slotZoomOuIn_"} );
	if getThisButtonPage == nil then return;end;
	local guiPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[getThisButtonPage.masterPage].side[getThisButtonPage.pageSide];
	local buttonTable = Utils.getNoNil(guiPageTable.line[getThisButtonPage.line].button[getThisButtonPage.button], nil);
	buttonTable.cmdTable = moSetGetOverlays.slot[whichSubSLOT];
	
	getThisButtonPage = g_currentMission.guiMenue.guiSetGet:getButtonInfo( {modMenueTable=MultiOverlayV3.guiMenue.modTable, pageSide=defaultPageSide, name="slotTextWidthFix_"} );
	if getThisButtonPage == nil then return;end;
	guiPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[getThisButtonPage.masterPage].side[getThisButtonPage.pageSide];
	buttonTable = Utils.getNoNil(guiPageTable.line[getThisButtonPage.line].button[getThisButtonPage.button], nil);
	buttonTable.cmdTable = moSetGetOverlays.slot[whichSubSLOT];
	
	getThisButtonPage = g_currentMission.guiMenue.guiSetGet:getButtonInfo( {modMenueTable=MultiOverlayV3.guiMenue.modTable, pageSide=defaultPageSide, name="slotHorizontalTxtDistance_"} );
	if getThisButtonPage == nil then return;end;
	guiPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[getThisButtonPage.masterPage].side[getThisButtonPage.pageSide];
	buttonTable = Utils.getNoNil(guiPageTable.line[getThisButtonPage.line].button[getThisButtonPage.button], nil);
	buttonTable.cmdTable = moSetGetOverlays.slot[whichSubSLOT];
	
	getThisButtonPage = g_currentMission.guiMenue.guiSetGet:getButtonInfo( {modMenueTable=MultiOverlayV3.guiMenue.modTable, pageSide=defaultPageSide, name="slotVerticalTxtDistance_"} );
	if getThisButtonPage == nil then return;end;
	guiPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[getThisButtonPage.masterPage].side[getThisButtonPage.pageSide];
	buttonTable = Utils.getNoNil(guiPageTable.line[getThisButtonPage.line].button[getThisButtonPage.button], nil);
	buttonTable.cmdTable = moSetGetOverlays.slot[whichSubSLOT];
	
	getThisButtonPage = g_currentMission.guiMenue.guiSetGet:getButtonInfo( {modMenueTable=MultiOverlayV3.guiMenue.modTable, pageSide=defaultPageSide, name="slotTxtSize_"} );
	if getThisButtonPage == nil then return;end;
	guiPageTable = g_currentMission.guiMenue.modTable[MultiOverlayV3.guiMenue.modTable].page[getThisButtonPage.masterPage].side[getThisButtonPage.pageSide];
	buttonTable = Utils.getNoNil(guiPageTable.line[getThisButtonPage.line].button[getThisButtonPage.button], nil);
	buttonTable.cmdTable = moSetGetOverlays.slot[whichSubSLOT];
end;







